;
;	>>> Chick-On-Chips - a very early version of R.G.B.A. <<<
;
;	Created in January 2010. Reworked for NYD 2013. Last updated 2022-08-21.

; Girls width: 	94,104, 88 pixel
; 		12, 13, 11 chars = 37 bytes

frame_height	= 100
frame_size	= 40*frame_height

priobit	= $1
prior09	= $40+priobit
prior10	= $80+priobit
prior11	= $c0+priobit
priorxx	= $c0

base		= $b000
priortab1	= base+$000
priortab2	= base+$100
xposp0		= base+$200
xposm0		= base+$300

dl1	= $d800
dl2     = $dc00
sm09	= $c000
sm10	= $e000
sm11	= $f000

cnt	= $14

a1      = $c0
even    = $c2

x1	= $d0

p1	= $e0
p2	= $e2
p3	= $e4

	opt l+

	icl "..\RGBA\RGBA-Kernel-Equates.asm"

;===============================================================

	org $9000

	.proc fader	;Fade out all 9 color registers
fade_loop
	ldy #0		;Assume all zero
	ldx #8
color_loop
	lda 704,x
	pha
	and #$f0
	sta fade_color
	pla
	and #15
	beq zero
	sec
	sbc #1
	ora #$00
fade_color = *-1
	tay		;At least one not zero

zero	sta 704,x
	dex
	bpl color_loop
	lda cnt
	clc
	adc #2
wait	cmp cnt
	bne wait
	cpy #0
	bne fade_loop
	rts
	.endp		;End of fade

	ini fader

;===============================================================

	org $2000

	icl "..\RGBA\RGBA-Kernel.asm"


start	jsr intro
	jmp main

	.proc intro

blend	= x1

	mwa #dl $230
	mva #>intro_chr 756

	mva #13 blend
blendup	jsr kernel
	lda cnt
	and #3
	bne blendup
	dec blend
	bne blendup

wait	jsr kernel

	lda $d20f
	and #12
	cmp #12
	bne continue_key
	lda $d01f
	and #7
	cmp #7
	bne continue_console
	jmp wait
continue_key
	jmp blenddown

continue_console
	and #1
	bne no_select
no_select
	jmp blenddown

blenddown
	jsr kernel
	lda cnt
	and #3
	bne blenddown
	inc blend
	lda blend
	cmp #13
	bne blenddown
	rts

;===============================================================

	.proc kernel
	lda #15
wait	cmp $d40b
	bne wait
	ldx #0
loop	txa
	and #7
	adc blend
	tay
	lda colors,y
	sta $d40a
	sta $d017
	inx
	cpx #192+8
	bne loop
	rts
	.endp

colors	.byte $04,$06,$08,$0a,$0c,$0e,$0c,$0a,$08,$06,$04,$02
	.byte $00,$00,$00,$00,$00,$00,$00,$00,$00
;===============================================================

	.align 1024

intro_chr
	ins "ChicksOnChips-Intro.chr"

	.local dl
	.byte $70,$70,$70
	.byte $42
	.word text
	.byte $70
	.byte $02,$02,$70,$02,$02,$02,$70
	.byte $02,$02,$02,$02,$70
	.byte $02,$02,$02,$70,$02,$02,$02,$02,$02,$70,$02
	.byte $41
	.word dl

	.endl

;===============================================================

text	.byte "         CHICKS ON CHIPS - 2010         "
	.byte "  THIS WAS THE FIRST STAGE OF MY DEMO   "
	.byte "  R.G.B.A. - RASTERS GIRLS BEER ATARI   "
	.byte "IT WAS CREATED IN JANUARY 2010, SO IT'S "
	.byte " SO ALMOST 3 YEARS FROM THE FIRST IDEA  "
	.byte "          TO THE FINAL RESULT.          "
	.byte " PRESS SPACE TO ACTIVATE THE COLOR BARS "
	.byte " AND TOGGLE THE GIRLS. THERE ARE THREE  "
	.byte " GIRLS IN THIS ONE. ONE HAD TO BE LEFT  "
	.byte "OUT FROM R.G.B.A. TO KEEP THE 16K LIMIT."
	.byte " THE BLACK DIAGONAL LINES LATER BECAME  "
	.byte "BORDES AROUND THE GIRLS WHICH REDUCE THE"
	.byte " INTERLACE FLICKER AND MASK CHAR LIMITS."
	.byte "THIS VERSION HAD NO MUSIC AND NO EFFECTS"
	.byte "BECAUSE THIS IS NORMAL TIP MODE AND NOT "
	.byte "THE CHARACTER INTERLACE USED IN R.G.B.A."
	.byte "STILL THIS IS 6671 BYTES LARGER, SO NOW "
	.byte "  YOU KNOW WHAT I DID ALL THE TIME :-)  "
	.byte "                         JAC! - NYD2013 "
	.endp

	.proc main
	sei
	lda #0
	sta dmactl
	sta nmien
	lda #$fe
	sta portb

	jsr clear_sm
	jsr generate_dl
	jsr remap_sm10
	jsr show_image
;	copy_memory chicks_tip+9+frame_size*0 sm09 frame_size
;	copy_memory chicks_tip+9+frame_size*1 sm10 frame_size
;	copy_memory chicks_tip+9+frame_size*2 sm11 frame_size

	jsr generate_mask
	jsr generate_tabs

	lda #$80
	sta grafp0	;left side border

	lda #$c0
	sta grafp1	;left girl border

	lda #$0f
	sta grafm	;right girl border, right side border

	lda #$30
	sta hposp0
	sta hposp1
	lda #$d0
	sta hposm0
	sta hposm1

loop	lda #0
	ldy #0
	jsr show_chick
	lda #13
	ldy #27
	jsr show_chick
	lda #26
	ldy #0
	jsr show_chick
	lda #13
	ldy #27
	jsr show_chick
	jmp loop
	.endp

;===============================================================

	.proc remap_sm10
	.var line_count .byte
	mwa #chicks_tip+9+frame_size*1 p1
	mva #frame_height line_count
line_loop
	ldy #39
byte_loop
	lda (p1),y
	jsr remap
	sta (p1),y
	dey
	bpl byte_loop
	dec line_count
	bne line_loop
	
	ldx #8
color_loop
	ldy sequence,x
	lda colors.original,y
	sta colors.mapped,x
	dex
	bpl color_loop
	rts
	
sequence dta 0,8,1,2,3,4,5,6,7

	.proc remap
	pha
	and #15
	tax
	cpx #9
	bcs error
	lda sequence,x
	sta x1
	pla
	lsr
	lsr
	lsr
	lsr
	tax
	cpx #9
	bcs error
	lda sequence,x
	asl
	asl
	asl
	asl
	ora x1
	rts

error	.byte $02
	.endp
	
	.endp

;===============================================================

	.proc generate_mask
	mwa #(chicks_mask) p1
	mwa #(chicks_mask+40) p2
	ldx #frame_height
mask_line
	ldy #39
mask_byte
	lda (p1),y
	ora (p2),y
	pha
	and #15
	beq *+4
	lda #15
	sta x1
	pla
	and #$f0
	beq *+4
	lda #$f0
	ora x1
	eor #$ff
	sta (p1),y
	sta (p2),y
	dey
	bpl mask_byte
	adw p1 #80
	adw p2 #80
	dex
	bne mask_line
	rts
	.endp

;===============================================================

	.proc generate_tabs
	ldx #0
prior_loop
 	lda #prior11
	sta priortab1,x
	sta priortab2,x
	inx
	ldy #prior09
	txa
	and #2
	beq *+4
	ldy #prior10
	tya
	sta priortab1,x
	eor #priorxx
	sta priortab2,x
	inx
	bne prior_loop

hpos_loop
	txa
	cmp #$80
	bcs *+3
	lsr
;	and #$f0
;	ora #$01
	sta xposp0,x
	inx
	bne hpos_loop
	rts
	.endp

;===============================================================

	.proc show_chick
	.var chick_a .byte
	.var chick_y .byte

	sta chick_a
	sty chick_y
	jsr fill_sm

	jsr wait_key

	lda chick_a
	ldy chick_y
	jsr fill_effect

	jsr wait_key
	jsr clear_sm
	rts
	.endp

;===============================================================

	.proc wait_key
key1	lda skstat
	and #12
	cmp #12
	beq key1
key2	lda skstat
	and #12
	cmp #12
	bne key2
	rts
	.endp

;===============================================================

	.proc clear_sm
	m_fill_memory sm09 frame_size $00
	m_fill_memory sm10 frame_size $00
	m_fill_memory sm11 frame_size $00
	rts
	.endp
	
;===============================================================

	.proc fill_sm
	clc
	adc #<[chicks_tip+9]
	sta p1
	lda #>[chicks_tip+9]
	adc #0
	sta p1+1

	sty x1
	lda #>sm09
	jsr copy_frame
	lda #>sm10
	jsr copy_frame
	lda #>sm11
	jsr copy_frame
	rts

copy_frame
	sta p2+1
	lda x1
	sta p2
	sta p3
	ldx #frame_height
copy_line
	ldy #12
copy_byte
	lda (p1),y
	sta (p2),y
	dey
	bpl copy_byte
	adw p1 #40
	adw p2 #40
	dex
	bne copy_line
	rts
	.endp


	.proc fill_effect
	clc
	adc #<[chicks_mask]
	sta mask_adr
	lda #>[chicks_mask]
	adc #0
	sta mask_adr+1
	tya
	clc
	sta chick_start
	adc #13
	sta chick_end

	sec
	lda mask_adr
	sbc chick_start
	sta mask_adr
	lda mask_adr+1
	sbc #0
	sta mask_adr+1

	lda #>sm09
	ldx #9
	jsr fill_frame
	lda #>sm10
	ldx #10
	jsr fill_frame
	lda #>sm11
	ldx #11
	jsr fill_frame
	rts

fill_frame
	sta p2+1
	stx mode
	mwa mask_adr p1
	lda #0
	sta p2

	ldx #frame_height
fill_line
	stx count
	ldy #39
fill_byte
	lda #$ff
	cpy chick_start
	bcc no_mask
	cpy chick_end
	bcs no_mask
	lda (p1),y
no_mask	sta mask

	lda count
	and #31
	cmp #16
	bcc *+4
	eor #31
	sta x1
	lda count
	lsr
	and #$f0
	ora x1
	sta color

	lda mode
	cmp #9
	bne not9
	lda color
	and #15
	sta x1
	asl
	asl
	asl
	asl
	ora x1
	jmp store

not9	cmp #10
	bne not10
	lda color
	and #15
	lsr
	sta x1
	asl
	asl
	asl
	asl
	ora x1
	jmp store

not10	cmp #11
	bne not11
	lda color
	and #$f0
	sta x1
	lsr
	lsr
	lsr
	lsr
	ora x1
store
	and mask
	ora (p2),y
	sta (p2),y
	inc count

not11
	dey
	bpl fill_byte
	adw p1 #80
	adw p2 #40
	dex
	jne fill_line
	rts

mask_adr	.word
chick_start	.byte
chick_end	.byte
mask	.byte
mode	.byte
count	.byte
color	.byte

	.endp
;===============================================================

	.proc generate_dl
	lda #$70
	jsr store_both
	jsr store_both
	lda #$60+$80
	jsr store_both
	lda #$00
	jsr store_both

	mwa #0 a1
	ldx #frame_height
loop	jsr generate_gr11
	lda a1
	add <sm09
	jsr store_dl1
	lda a1+1
	adc >sm09
	jsr store_dl1
	lda a1
	add <sm10
	jsr store_dl2
	lda a1+1
	adc >sm10
	jsr store_dl2
	jsr next_line
	jsr generate_gr11
	lda a1
	add <sm10
	jsr store_dl1
	lda a1+1
	adc >sm10
	jsr store_dl1
	lda a1
	add <sm09
	jsr store_dl2
	lda a1+1
	adc >sm09
	jsr store_dl2
	jsr next_line
	bne loop
	lda #$41
	jsr store_both
	lda <dl1
	jsr store_both
	lda >dl1
	jmp store_both

generate_gr11
	lda #$4f
	jsr store_both
	lda a1
	add <sm11
	jsr store_both
	lda a1+1
	adc >sm11
	jsr store_both
	lda #$4f
	jmp store_both

store_both
	jsr store_dl2
store_dl1
	sta dl1
        inw store_dl1+1
        rts
store_dl2
        sta dl2
        inw store_dl2+1
        rts

next_line
        adw a1 #40
       	dex
        rts
 
	.endp

;===============================================================

	.local colors
original	dta 0,2,4,6,8,10,12,14,0
mapped		dta 0,2,4,6,8,10,12,14,0
	.endl

	.proc show_image
	ldx #8
	mva:rpl colors.mapped,x $d012,x-

        mwa #dl1 $d402
	mwa #nmi $fffa
	mwa #irq $fffe
	
	mva #0 even
	
	lda #3
	sta $d20f
	lda #1
	sta $d208
	lda #4
	sta $d200

;	cli
	lda vcount
	bne *-3
	mva #$c0 nmien
	mva #$22 dmactl
	rts
	.endp



;===============================================================

	.proc nmi
	bit $d40f
	jpl vbi

	.proc dli
	
	.macro pos
	lda xposp0,x
	sta hposp0
	add #8
	sta hposm0
	inx
	.endm

	pha
	txa
	pha
;	lda #4
;dli_flag = *-1
;	sta irqen
;	eor #4
;	sta dli_flag
	lda colors.mapped+8
	sta color8a
	sta color8b
	lda colors.mapped
	sta wsync
	sta $d01a
	ldx #0
	lda even
	beq loop2

loop1	lda #prior11
	sta wsync
	sta prior
	lda #0
	sta $d01a
	pos

	lda #prior10
	sta wsync
	sta prior
	lda #0
color8a = *-1
	sta $d01a
	pos

	lda #prior11
	sta wsync
	sta prior
	lda #0
	sta $d01a
	pos

	lda #prior09
	sta wsync
	sta prior
	lda #0
	sta $d01a
	pos

	cpx #200
	bne loop1
	jmp bottom

loop2	lda #prior11
	sta wsync
	sta prior
	lda #0
	sta $d01a
	pos

	lda #prior09
	sta wsync
	sta prior
	lda #0
	sta $d01a
	pos

	lda #prior11
	sta wsync
	sta prior
	lda #0
	sta $d01a
	pos

	lda #prior10
	sta wsync
	sta prior
	lda #0
color8b = *-1
	sta $d01a
	pos

	cpx #200
	bne loop2
	jmp bottom
bottom	lda colors.mapped
	sta wsync
	sta $d01a
	sta prior
	sta wsync
	sta $d01a
	pla
	tax
	pla
	rti
	.endp	;End of dli

	.proc vbi
	sta $d40f
	pha
	mva #0 irq.line_cnt
;	mva #4 dli.dli_flag
	lda #1
	eor even
	sta even
	bne vbi1
	mwa #dl1 dlptr
;	mva #>priortab1 dli.priortab_adr+1
	pla
	rti

vbi1	mwa #dl2 dlptr
;	mva #>priortab2 dli.priortab_adr+1
	pla
	rti
	.endp	;End of vbi
	
	.endp	;End of nmi


	org $80

	.proc irq
	sta save_a 
	stx save_x
	lda #0
	sta irqen
	lda #4
	sta irqen

	ldx #0
line_cnt = *-1

	lda priortab1,x
priortab_adr = *-2
	inc line_cnt
	sta prior
	lda xposp0,x
	sta hposp1
;	stx $d01a
;	lda xposm0,x
;	sta hposm0
	ldx #0
save_x = *-1
	lda #0
save_a = *-1
	rti
	.endp
	

	org $3000
chicks_tip
	ins "../RGBA/gfx/tip/chicks-jakub-2.5.tip"

	org $6000
chicks_mask
	ins "../RGBA/gfx/mask/chicks-mask.pic"

	run start